
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY register_8_v1_register_8_v1_sch_tb IS
END register_8_v1_register_8_v1_sch_tb;
ARCHITECTURE behavioral OF register_8_v1_register_8_v1_sch_tb IS 

   COMPONENT register_8_v1
   PORT( CLR	:	IN	STD_LOGIC; 
          CLK	:	IN	STD_LOGIC; 
          CE	:	IN	STD_LOGIC; 
          D	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          Q	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0));
   END COMPONENT;

   SIGNAL CLR	:	STD_LOGIC;
   SIGNAL CLK	:	STD_LOGIC;
   SIGNAL CE	:	STD_LOGIC;
   SIGNAL D	:	STD_LOGIC_VECTOR (7 DOWNTO 0);
   SIGNAL Q	:	STD_LOGIC_VECTOR (7 DOWNTO 0);

BEGIN

   UUT: register_8_v1 PORT MAP(
		CLR => CLR, 
		CLK => CLK, 
		CE => CE, 
		D => D, 
		Q => Q
   );
	
	clock: PROCESS
	BEGIN
		CLK <= '0'; 
		WAIT FOR 100 ns;
		CLK <= '1'; 
		WAIT FOR 100 ns;
	END PROCESS;

   tb : PROCESS
   BEGIN
		D   <= "00000000";
		CE  <= '0';
		CLR <= '0';
		WAIT FOR 550 ns;
		
		D   <= "01111011";
		CE  <= '0';
		CLR <= '0';
		WAIT FOR 200 ns;
				
		D   <= "01111011";
		CE  <= '1';
		CLR <= '0';
		WAIT FOR 200 ns;	
		
		D   <= "01111011";
		CE  <= '0';
		CLR <= '0';
		WAIT FOR 200 ns;	
		
		D   <= "01111011";
		CE  <= '0';
		CLR <= '1';
		WAIT FOR 200 ns;	
		
		D   <= "00000000";
		CE  <= '0';
		CLR <= '0';
		WAIT FOR 200 ns;
				
		D   <= "00101101";
		CE  <= '1';
		CLR <= '0';
		WAIT FOR 200 ns;	
		
		D   <= "00101101";
		CE  <= '0';
		CLR <= '0';
		WAIT FOR 200 ns;	

		D   <= "00000000";
		CE  <= '0';
		CLR <= '0';
		WAIT FOR 200 ns;
		
		D   <= "00000000";
		CE  <= '1';
		CLR <= '0';
		WAIT FOR 200 ns;

		D   <= "00000000";
		CE  <= '0';
		CLR <= '0';
		WAIT FOR 200 ns;
		
      WAIT; -- will wait forever
   END PROCESS;


END;
